(****************************************************************************)
(* Akiss                                                                    *)
(* Copyright (C) 2011-2014 Baelde, Ciobaca, Delaune, Kremer                 *)
(*                                                                          *)
(* This program is free software; you can redistribute it and/or modify     *)
(* it under the terms of the GNU General Public License as published by     *)
(* the Free Software Foundation; either version 2 of the License, or        *)
(* (at your option) any later version.                                      *)
(*                                                                          *)
(* This program is distributed in the hope that it will be useful,          *)
(* but WITHOUT ANY WARRANTY; without even the implied warranty of           *)
(* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            *)
(* GNU General Public License for more details.                             *)
(*                                                                          *)
(* You should have received a copy of the GNU General Public License along  *)
(* with this program; if not, write to the Free Software Foundation, Inc.,  *)
(* 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.              *)
(****************************************************************************)

(** Rewriting utilities for terms.
  * This module does not support AC connectives. *)

open Term

exception Not_unifiable
exception Not_matchable
exception No_easy_unifier
exception No_easy_match

(** Unification and matching for free terms *)

val mgu : term -> term -> subst
val mgm : term -> term -> subst
val mgmac : term -> term -> subst
val equals_ac : term -> term -> bool

(** Utilities for handling a (non-AC) theory *)

val normalize : term -> (term * term) list -> term
val variants : term -> rules -> (term * subst) list
val unifiers : term -> term -> rules -> subst list
